program jcCompressAxes
  ! Program to compress axes
  ! Runs through all dimensions and puts everything on n2 axis
  ! Made for when creating daily stacks

  
  use sep
  implicit none


  ! declare variables
  ! general program variables
  integer                       :: ii,jj,kk,ll

  ! data and header file variables
  integer                       :: n1,n2,n3,n4,n5
  integer                       :: n1xy,n2xy,n3xy,n4xy,n5xy
  real,allocatable,dimension(:) :: datain,headerin

  ! statistics parameters
  integer                       :: ntraces
  real                          :: summ


  ! open I/O
  call sep_init()

  ! grab data parameters
  call from_history('n1',n1,1200)
  call from_history('n2',n2,1   )
  call from_history('n3',n3,1   )
  call from_history('n4',n4,1   )
  call from_history('n5',n5,1   )

  ! grab header file parameters
  if (exist_file("xy_in")) then
    call from_aux("xy_in",'n1',n1xy)
    call from_aux("xy_in",'n2',n2xy)
    call from_aux("xy_in",'n3',n3xy)
    call from_aux("xy_in",'n4',n4xy)
    call from_aux("xy_in",'n5',n5xy)
    ! check that correct size
    if ((n2.ne.n2xy).or.(n3.ne.n3xy).or.(n4.ne.n4xy).or.(n5.ne.n5xy)) then
      call seperr("Data and Header files not same dimensions")
    end if
  else
    call seperr("Need input header file")
  end if

  ! allocate
  allocate(datain(n1))
  allocate(headerin(n1xy))
  ntraces = 0

  ! loop over all axes of data
  do ll=1,n5
    do kk=1,n4
      do jj=1,n3
        do ii=1,n2
          ! read in data and header
          call sreed("in",datain,4*n1)
          call sreed("xy_in",headerin,4*n1xy)

          ! check sum of data
          summ = sum(datain)

          ! if sum is not zero, then do write out
          if (summ.ne.0) then
            call srite("out",datain,4*n1)
            call srite("xy_out",headerin,4*(n1xy-1))
            ntraces = ntraces+1
          end if

        end do
      end do
    end do
  end do

  ! write out proper dimensions at end
  call to_history("n1",n1)
  call to_history("n2",ntraces)
  call to_history("o2",1.)
  call to_history("d2",1.)
  call to_history("n3",1 )
  call to_history("o3",1.)
  call to_history("d3",1.)
  call to_history("n4",1 )
  call to_history("o4",1.)
  call to_history("d4",1.)
  call to_history("n5",1 )
  call to_history("o5",1.)
  call to_history("d5",1.)

  if (exist_file("xy_out")) then
    call to_history("n1",(n1xy-1),"xy_out")
    call to_history("n2",ntraces,"xy_out")
    call to_history("o2",1.,"xy_out")
    call to_history("d2",1.,"xy_out")
    call to_history("n3",1 ,"xy_out")
    call to_history("o3",1.,"xy_out")
    call to_history("d3",1.,"xy_out")
    call to_history("n4",1 ,"xy_out")
    call to_history("o4",1.,"xy_out")
    call to_history("d4",1.,"xy_out")
    call to_history("n5",1 ,"xy_out")
    call to_history("o5",1.,"xy_out")
    call to_history("d5",1.,"xy_out")
  end if

  call sep_close()

  ! clean up
  deallocate(datain,headerin)


end program
