program jcNormalize
  ! Program to normalize according to maximum amplitude on axis 1
  !
  ! Input:
  !   1) history file
  !
  ! Output:
  !   1) history file

  use sep
  implicit none

  ! declare variables
  integer                           :: ii
  integer                           :: n1,n2,n3,n4
  real                              :: maxi
  real,allocatable,dimension (:)    :: datain

  ! open I/O
  call sep_init()

  call from_history('n1',n1,1)
  call from_history('n2',n2,1)
  call from_history('n3',n3,1)
  call from_history('n4',n4,1)

  call sep_close()

  ! allocate
  allocate(datain(n1))

  do ii=1,n2*n3
    ! read in data
    call sreed("in",datain,4*n1)

    ! find maximum value/amplitude
    maxi = maxval(abs(datain))

    ! divide all elements by maxval
    call srite("out",datain/maxi,4*n1)
  end do

  ! clean up
  deallocate(datain)

end program
