program sdrSIcausalstack

  use sep
  implicit none

  integer          :: n1,n2,n3,nt
  real             :: d1,d2,d3
  real             :: o1,o2,o3,ot

  real,allocatable :: datain(:)
  real,allocatable :: datout(:)

  integer          :: ii,jj,kk

  logical          :: sym

  call sep_init()

  call from_history('n1',n1,1 )
  call from_history('n2',n2,1 )
  call from_history('n3',n3,1 )
 
  call from_history('d1',d1,1.)
  call from_history('d2',d2,1.)
  call from_history('d3',d3,1.)

  call from_history('o1',o1,0.)
  call from_history('o2',o2,0.)
  call from_history('o3',o3,0.)
  
  call from_param('symmetrize',sym,.false.)

  nt = 1+n1/2;
  ot = 0.;
  
  if (.not.sym)  call to_history('n1',nt)
  if (.not.sym)  call to_history('o1',ot)
  
  call sep_close()
  
  allocate(datain(n1))
  if (     sym)  allocate(datout(n1))
  if (.not.sym)  allocate(datout(nt))

  
  do kk=1,n3
  do jj=1,n2
    
    datain=0.
    datout=0.
    
    call sreed("in" ,datain,4*size(datain))
    
    if (.not.sym) then
      datout(1)      =   datain(nt)
      do ii=1,nt-2
        datout(1+ii) = ( datain(nt+ii) + datain(nt-ii) ) / 2.
      end do
      datout(nt)     =   datain(1 )
    else
      datout(nt)      =   datain(nt)
      do ii=1,nt-2
        datout(nt+ii) = ( datain(nt+ii) + datain(nt-ii) ) / 2.
        datout(nt-ii) = ( datain(nt+ii) + datain(nt-ii) ) / 2.
      end do
      datout(1 )      =   datain(1 )
    end if
    
    call srite("out",datout,4*size(datout))
    
  end do
  end do
  
  deallocate(datain)
  
end program
